#! /usr/bin/perl
#Name: R7-status.pl
#Project: R7 control
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 12.09.2017
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Server script displays the status of the rover. Script is called by Javascript from control panel of the webpage

use strict;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);

my $numArgs = 0;
my $argument_user = "";
my $argument_id = "";
my $argument_command = "";
my $argument_ip = "";
my $user_in_file = "";
my $UserID_in_file = "";
my $UserIP_in_file = "";
my $file_access = "R7access.txt";
my $file_server_status = "R7-connect.txt";
my $file_server_service = "service.txt";
my $in_line = "";
my $type_style =  '; font-family:serif,Times,serif; font-size:12px; color:#000000"';
my $type_style_large =  '; font-family:serif,Times,serif; font-size:20px; color:#000000"';
my $user_is_ok = 0;
my $temp_char = "";
my $i = 0;
my $allowed_chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_";
my $access_time = 0;
my $first_access_time = 0;
my $access_time = 0;
my @file_info;
my $file_size = 0;
my $file_out = "R7command.txt";
my $id = "";
my $ipAddress = "";
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);
my $seconds_cdn;
my $minutes_cdn;
my $hours_cdn;
my $day_of_month_cdn;
my $month_cdn;
my $year_cdn;
my $CTIME_String = localtime(time);
my $Language = param("Language");
my $UserName = param("UserName");
my $UserID = param("UserID");
my $Command = param("Command");
my $batteryStatus = 0;

my $name_bitmap = "";


if($Language ne ""){
  $numArgs++;
}
if($UserName ne ""){
  $numArgs++;
}
if($UserID ne ""){
  $numArgs++;
}
if($Command ne ""){
  $numArgs++;
}


if(-e "BatteryStatus.txt"){
  open(DATEIIN, '<BatteryStatus.txt');
    $batteryStatus = <DATEIIN>;
  close (DATEIIN);
  if($batteryStatus > 1024){
    $batteryStatus -= 1024;
  }
}

print "Content-type: text/html\n\n";
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">' . "\n";
print "<html><head><title>R7 Status</title>" . "\n";

print "</head><body style=\"margin-top: 0px;margin-bottom: 0px;margin-left: 0px;margin-right: 0px;\">";
print '<table border="0" cellpadding="0" cellspacing="0"><tr>' . "\n";


  if($numArgs < 1){#Script has to be called with at least 1 Argument
    print '<td style="background-color:#FF0000' . $type_style . '">Not enough parameters given!</td></tr></table></body></html>';
    exit(0);
  }


  if(time() - (stat("LastCallFromRover.txt"))[9] > 30){#Connection R7-server cut
    if($Language eq "ge"){
      print '<td style="background-color:#FF0000' . $type_style . '>Verbindung zu R7 unterbrochen.<br>Verbindungsaufbau in Bearbeitung...</td>';
    }
    else{
      print '<td style="background-color:#FF0000' . $type_style . '>R7 currently not connected.<br>Reconnection in progress...</td>';
    }
    print "</tr></table></body></html>" . "\n";
    if(!(-e "LostConnection.bmp")){
      `cp IndicationPicture01.bmp LostConnection.bmp`;
    }
    exit(0);
  }


  if($numArgs == 4){#Call with language, Username, UserID and R7 command
    $argument_user = $UserName;
    $argument_user .= ( "                    ");
    $argument_user = substr($argument_user, 0, 20);

    $temp_char=$argument_user;
    $temp_char =~ s/^ +//;
    $temp_char =~ s/ +$//;
    for($i = 0; $i < length($temp_char); $i++){
      if(index($allowed_chars, substr($temp_char, $i, 1)) < 0) {
        if($Language eq "ge"){
          print '<td style="background-color:#00FF00' . $type_style . '>Nicht erlaubtes Zeichen im Benutzernamen!!</td></tr></table><</body></html>';
        }
        else{
          print '<td style="background-color:#00FF00' . $type_style . '>Not allowed character in username!</td></tr></table><</body></html>';
        }
        exit(0);
      }
    }

    $argument_id = $UserID;
    $argument_id .= ( "                    ");
    $argument_id = substr($argument_id, 0, 20);
    $argument_command = $Command;
    $argument_command .= ( "                    ");
    $argument_command = substr($argument_command, 0, 20);
    $argument_ip = $ENV{'REMOTE_ADDR'};
    $argument_ip .= ("                    ");
    $argument_ip = substr($argument_ip, 0, 20);
    $access_time = time() . "                    ";
    $access_time = substr($access_time, 0, 20);

    @file_info=stat($file_access);
    $file_size = $file_info[7];

    if ($file_size < 1000){
      open(DATEIOUT,'>>'.$file_access) || die '<td style="background-color:#FF0000' . $type_style . '>Can not open file' .  $file_access . '. Please try again.</td></tr></table></body></html>';
        print DATEIOUT $argument_user . $argument_id . $argument_ip . $access_time . "_\n";
      close (DATEIOUT);
    }

    #Compare command line arguments with those iside of the first line in file R7access.txt
    open(DATEIIN, '<'.$file_access) || die '<td style="background-color:#FF0000' . $type_style . '>File ' .  $file_access . ' not found, please try again.</td></tr></table></body></html>';
      $in_line = <DATEIIN>;
    close (DATEIIN);

    $user_in_file = substr($in_line, 0, 20);
    $id = substr($in_line, 20, 20);
    $ipAddress = substr($in_line, 40, 20);
    $first_access_time = substr($in_line, 60, 20);

    $name_bitmap = $user_in_file;
    $name_bitmap =~ s/^\s+|\s+$//g;
    $name_bitmap = "hidden/" . $name_bitmap . "-" . substr($id, 0, 5) . "-CurrentUser.bmp";
    if(!(-e $name_bitmap)){
      system("cp IndicationPicture01.bmp " . $name_bitmap);
      $name_bitmap = $user_in_file;
      $name_bitmap =~ s/^\s+|\s+$//g;
      $name_bitmap = "hidden/" . $name_bitmap . "-" . substr($id, 0, 5) . ".usr";
      open(DATEIOUT, '>'.$name_bitmap) || die '<td style="background-color:#FF0000' . $type_style . '>File ' .  $name_bitmap . ' not found, please try again.</td></tr></table></body></html>';
        print DATEIOUT $ENV{'REMOTE_ADDR'};;
      close (DATEIOUT);
    }

    $name_bitmap = $user_in_file;
    $name_bitmap =~ s/^\s+|\s+$//g;
    $name_bitmap = $name_bitmap . "-" . substr($id, 0, 2) . "-CurrentUser.bmp";
    if(!(-e $name_bitmap)){
      system("cp IndicationPicture01.bmp " . $name_bitmap);
    }

    if ($argument_user eq $user_in_file and $argument_id eq $id){#User and ID from commandline equals those at the first line of R7access.txt
      $user_is_ok = 1;
      if($Language eq "ge"){
        print '<td style="background-color:#00FF00' . $type_style . '>R7 steht unter deinem Kommando: "' . $user_in_file . '"</td>';
      }
      else{
        print '<td style="background-color:#00FF00' . $type_style . '>R7 is under your control: "' . $user_in_file . '"</td>';
      }
      if(-e $file_out){
        if($Language eq "ge"){
          print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Kommandopipeline noch nicht frei. Versuch es in 5 Sekunden nochmal.</td>';
        }
        else{
          print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Command pipe not free for new command. Please try again in five seconds.</td>';
        }
      }
      else{#Write command to file
        if(-e "RoverCommand.bmp"){
          `rm RoverCommand.bmp`;
        }
        if(-e "R7Free.bmp"){
          `rm R7Free.bmp`;
        }

        $access_time = time() . "                    ";
        $access_time = substr($access_time, 0, 20);
        open(DATEIOUT,'>'.$file_out) || die '<td style="background-color:#FF0000' . $type_style . '>Can not open command file' .  $file_out . '. Please try again.</td></tr></table></body></html>';
          print DATEIOUT $argument_command . $access_time . $ipAddress . $user_in_file . "_\n";
        close (DATEIOUT);
        $argument_command =~ s/^ +//;
        $argument_command =~ s/ +$//;
        if(substr($Command, 9, 1) eq "1" || substr($Command, 9, 1) eq "2" || substr($Command, 9, 1) eq "3"){#Snapshot, restart stream
          open(DATEIOUT,'> ReconnectStream.txt') || die '<td style="background-color:#FF0000' . $type_style . '>Can not create ReconnectStream.txt!</td></tr></table></body></html>';
            print DATEIOUT "Comm=" . substr($argument_command, 1, 20);
          close (DATEIOUT);
          `rm -f StreamIsUp.gif`;

          if($Language eq "ge"){
            print '</tr><tr><td style="background-color:#FF0000' . $type_style . '">Videostream wird neu gestartet - Bitte warten...</td>';
          }
          else{
            print '</tr><tr><td style="background-color:#FF0000' . $type_style . '">Restarting video stream - Please wait...</td>';
          }
        }
        else{
          if($Language eq "ge"){
            print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $argument_command . ' an R7 &uuml;bermittelt.</td>';
          }
          else{
            print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $argument_command . ' sent to R7</td>';
          }
        }
      }
    }#if ($argument_user eq $user_in_file and $argument_id eq $id)
    else{
      $user_is_ok = 2;
      if($Language eq "ge"){
        print '<td style="background-color:#FF0000' . $type_style . '>R7 wird zur Zeit gesteuert von: "' . $user_in_file . '"</td>';
      }
      else{
        print '<td style="background-color:#FF0000' . $type_style . '>R7 currently in use by: "' . $user_in_file . '"</td>';
      }
      $user_in_file =~ s/^ +//;
      $user_in_file =~ s/ +$//;
      $ipAddress =~ s/^ +//;
      $ipAddress =~ s/ +$//;
      if($Language eq "ge"){
        print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Warte bitte, bis der R7 freigegeben wird! In 5-Minuten-Intervallen erfolgt die Freigabe.</td>';
      }
      else{
        print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Please wait until R7 is free! After 5min the control is released.</td>';
      }
    }#if ($argument_user eq $user_in_file and $argument_id eq $id) - else construct
  }#if($numArgs == 4){


  if($numArgs == 3){#Call without transmitted command (fourth argument). Display status.
    if($user_is_ok == 0){
      if( -e $file_access){
        open(DATEIIN, '<'.$file_access) || die '<td style="background-color:#FFFFFF' . $type_style . '>File ' .  $file_access . ' not found, please try again.</td></tr></table></body></html>';
          $in_line = <DATEIIN>;
        close (DATEIIN);
      }
      else{
        $in_line = "";
      }

      if($in_line eq ""){
        if($Language eq "ge"){
          print '<td style="background-color:#FFFF00' . $type_style . '>R7 steht zur Verf&uuml;gung. Klick auf eine Kontrollfl&auml;che, um die Steuerung zu &uuml;bernehmen...</td>' . "\n";
        }
        else{
          print '<td style="background-color:#FFFF00' . $type_style . '>R7 free for use. Press one of the command buttons to take control...</td>' . "\n";
        }
      }
      else{
        $user_in_file = substr($in_line, 0, 20);
        $UserID_in_file = substr($in_line, 20, 20);
        $UserIP_in_file = substr($in_line, 40, 20);
        $user_in_file =~ s/^ +//;
        $user_in_file =~ s/ +$//;
        $UserID_in_file =~ s/^ +//;
        $UserID_in_file =~ s/ +$//;
        $UserIP_in_file =~ s/^ +//;
        $UserIP_in_file =~ s/ +$//;
        $UserIP_in_file = substr($UserIP_in_file, 0, rindex($UserIP_in_file, ".")) . ".xxx";
        $argument_user = $UserName;
        $argument_id = $UserID;

        if($UserID_in_file eq $argument_id && $user_in_file eq $argument_user){
          if($Language eq "ge"){
            print '<td style="background-color:#00FF00' . $type_style . '>R7 steht unter deinem Kommando: "' . $user_in_file . '"</td>' . "\n";
          }
          else{
            print '<td style="background-color:#00FF00' . $type_style . '>R7 is under your control: "' . $user_in_file . '"</td>' . "\n";
          }
        }
        else{
          if($Language eq "ge"){
            print '<td style="background-color:#FF0000' . $type_style . '>R7 steht unter dem Kommando von: "' . $user_in_file . '"</td>' . "\n";
          }
          else{
            print '<td style="background-color:#FF0000' . $type_style . '>R7 currently in use by: "' . $user_in_file . '"</td>' . "\n";
          }
        }
        if (-e "R7command.txt"){
          if($Language eq "ge"){
            print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>Verarbeite aktuellen Befehl - bitte warten (normalerweise 10 bis 30Sekunden bis zum neuen Bild).</td>' . "\n";
          }
          else{
            print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>Processing current command - please wait (usually 10 to 30 seconds) for new pic.</td>' . "\n";
          }
        }
        else{
          if($Language eq "ge"){
            print '</tr><tr><td style="background-color:#FFFF00' . $type_style . '>Hallo Kontrollstation auf dem Planeten Erde, klick auf eine Kontrollfl&auml;che, um den n&auml;chsten Befehl zu &uuml;bermitteln!</td>' . "\n";
          }
          else{
            print '</tr><tr><td style="background-color:#FFFF00' . $type_style . '>Hello control station on planet Earth, press a control button to transmit the next instruction!</td>' . "\n";
          }
        }
      }
    }#if($user_is_ok == 0)
  }#if($numArgs  == 3){


print "</tr></table></body></html>" . "\n";

exit (0);


#+++++++++++++++++++++++++ getDate ++++++++++++++++++++++++++++++++++++++++++++++++++

sub getDate{
  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }
}

